/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MMLFactoryImpl extends EFactoryImpl implements MMLFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static MMLFactory init()
  {
    try
    {
      MMLFactory theMMLFactory = (MMLFactory)EPackage.Registry.INSTANCE.getEFactory(MMLPackage.eNS_URI);
      if (theMMLFactory != null)
      {
        return theMMLFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new MMLFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MMLFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case MMLPackage.MML_MODEL: return createMMLModel();
      case MMLPackage.DATA_INPUT: return createDataInput();
      case MMLPackage.CSV_SEPARATOR: return createCSVSeparator();
      case MMLPackage.ML_CHOICE: return createMLChoice();
      case MMLPackage.ML_ALGORITHM: return createMLAlgorithm();
      case MMLPackage.REGRESSION_TREE: return createRegressionTree();
      case MMLPackage.LINEAR_REGRESSION: return createLinearRegression();
      case MMLPackage.VARIABLES: return createVariables();
      case MMLPackage.TARGET: return createTarget();
      case MMLPackage.DEFAULT_TARGET: return createDefaultTarget();
      case MMLPackage.NAMED_TARGET: return createNamedTarget();
      case MMLPackage.PREDICTIONS: return createPredictions();
      case MMLPackage.ALL_VARIABLES: return createAllVariables();
      case MMLPackage.PREDICTOR_VARIABLES: return createPredictorVariables();
      case MMLPackage.ITEM: return createItem();
      case MMLPackage.EVALUATION: return createEvaluation();
      case MMLPackage.STRATEGY_EVALUATION: return createStrategyEvaluation();
      case MMLPackage.SIMPLE_SPLIT: return createSimpleSplit();
      case MMLPackage.CROSS_VALIDATION: return createCrossValidation();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case MMLPackage.ML_FRAMEWORK:
        return createMLFrameworkFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case MMLPackage.ML_FRAMEWORK:
        return convertMLFrameworkToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MMLModel createMMLModel()
  {
    MMLModelImpl mmlModel = new MMLModelImpl();
    return mmlModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public DataInput createDataInput()
  {
    DataInputImpl dataInput = new DataInputImpl();
    return dataInput;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public CSVSeparator createCSVSeparator()
  {
    CSVSeparatorImpl csvSeparator = new CSVSeparatorImpl();
    return csvSeparator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MLChoice createMLChoice()
  {
    MLChoiceImpl mlChoice = new MLChoiceImpl();
    return mlChoice;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MLAlgorithm createMLAlgorithm()
  {
    MLAlgorithmImpl mlAlgorithm = new MLAlgorithmImpl();
    return mlAlgorithm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public RegressionTree createRegressionTree()
  {
    RegressionTreeImpl regressionTree = new RegressionTreeImpl();
    return regressionTree;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public LinearRegression createLinearRegression()
  {
    LinearRegressionImpl linearRegression = new LinearRegressionImpl();
    return linearRegression;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Variables createVariables()
  {
    VariablesImpl variables = new VariablesImpl();
    return variables;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Target createTarget()
  {
    TargetImpl target = new TargetImpl();
    return target;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public DefaultTarget createDefaultTarget()
  {
    DefaultTargetImpl defaultTarget = new DefaultTargetImpl();
    return defaultTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NamedTarget createNamedTarget()
  {
    NamedTargetImpl namedTarget = new NamedTargetImpl();
    return namedTarget;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Predictions createPredictions()
  {
    PredictionsImpl predictions = new PredictionsImpl();
    return predictions;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public AllVariables createAllVariables()
  {
    AllVariablesImpl allVariables = new AllVariablesImpl();
    return allVariables;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public PredictorVariables createPredictorVariables()
  {
    PredictorVariablesImpl predictorVariables = new PredictorVariablesImpl();
    return predictorVariables;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Item createItem()
  {
    ItemImpl item = new ItemImpl();
    return item;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Evaluation createEvaluation()
  {
    EvaluationImpl evaluation = new EvaluationImpl();
    return evaluation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public StrategyEvaluation createStrategyEvaluation()
  {
    StrategyEvaluationImpl strategyEvaluation = new StrategyEvaluationImpl();
    return strategyEvaluation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public SimpleSplit createSimpleSplit()
  {
    SimpleSplitImpl simpleSplit = new SimpleSplitImpl();
    return simpleSplit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public CrossValidation createCrossValidation()
  {
    CrossValidationImpl crossValidation = new CrossValidationImpl();
    return crossValidation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MLFramework createMLFrameworkFromString(EDataType eDataType, String initialValue)
  {
    MLFramework result = MLFramework.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertMLFrameworkToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public MMLPackage getMMLPackage()
  {
    return (MMLPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static MMLPackage getPackage()
  {
    return MMLPackage.eINSTANCE;
  }

} //MMLFactoryImpl
